# CSC334, Midterm, Fall 2015
# implement BWT

# Solution Set

# (a) write a function that returns a list
#     of all cyclic permutations of string S,
#     starting with S$ and ending with $S
def cyclic_perms(S):
    S = S + '$'
    perms = []
    for i in range(len(S)):
        perms.append(S[i:] + S[:i])
    return perms


def bwt(S):

    # (a) find all cyclic perms pi
    pi = cyclic_perms(S)

    # (b) sort permutations to find pi_sorted
    pi_sorted = sorted(pi)

    # (c) return the BWT (last column)
    L = ''
    for i in range(len(pi_sorted)):
        L += pi_sorted[i][-1]

    return L


# helper to return the index of the kth occurence of base (recursive)
# k = 0 means the 0th occurence
def idx(S, base, k, curr_idx):
    if k == 0:
        return curr_idx + S.index(base)
    else:
        new_idx = S.index(base) + 1
        return idx(S[new_idx:], base, k-1, curr_idx + new_idx)


# reverse the bwt to obtain the original string S
def reverse_bwt(L):
    # first column
    F = ''.join(sorted(L))

    S = ''
    f_idx = 0
    for i in range(len(L)):

        S = F[f_idx] + S
        l_base = L[f_idx]
        num_occ = L[:f_idx+1].count(l_base)-1
        f_idx = idx(F, l_base, num_occ, 0) 
    
    return S

        
# TESTING -------------


L = bwt('GTCACA')
print(L)

S = reverse_bwt(L)
print(S)

L2 = bwt('GTCAAAACCTTTTGGGGCCAGAGACA')
print(L2)

S2 = reverse_bwt(L2)
print(S2)
